#line 1 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/MCP9801_Temperatura/MCP8901 Sonda Temp/MCP8901_Sonda_Temp.c"
#line 100 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/MCP9801_Temperatura/MCP8901 Sonda Temp/MCP8901_Sonda_Temp.c"
 sbit LED_1 at LATC5_bit;
 sbit LED_2 at LATC4_bit;
 sbit LED_3 at LATC3_bit;
 sbit LED_4 at LATC6_bit;
 sbit LED_5 at LATC7_bit;
 sbit LED_6 at LATB7_bit;
 sbit LED_7 at LATB6_bit;
 sbit LED_8 at LATB5_bit;
 sbit LED_9 at LATB4_bit;
 sbit LED_10 at LATC2_bit;
 sbit LED_11 at LATC1_bit;

 sbit pul_1 at RB7_bit;
 sbit pul_2 at RB5_bit;
 sbit pul_3 at RB6_bit;
 sbit pul_4 at RB4_bit;
 sbit pul_5 at RA4_bit;
 sbit pul_6 at RA3_bit;

 sbit ana_4 at RC0_bit;
 sbit ana_5 at RC1_bit;

 sbit UART_Rx at RA1_bit;
 sbit UART_Tx at RA0_bit;

 sbit alert at RA2_bit;








 typedef struct {
 unsigned pul : 1;
 unsigned half_set : 1;
 unsigned half_hyst : 1;
 unsigned mode : 1;
 unsigned led : 1;

 } Flags;
 Flags flag;

 unsigned char const jumbo [] ={"JUMBO elettr."};
 unsigned char const txt_set [] ={"Tset"};
 unsigned char const txt_hyst [] ={"Thys"};
 unsigned char const txt_on [] ={"ON"};
 unsigned char const txt_off [] ={"--"};

 unsigned char cnt_led;
 char txt[7], txt2[5];
 char txt32[11];

 char buf;
 char ADC_ch;
 unsigned int temp16;
 unsigned int media_stack[32];
 char cnt_media = 0;
 unsigned int media;
 unsigned int data1, data2, data3, data4, data5, data6, data7, data8;
 unsigned int temperatura;
 char contr_set, contr_hyst, contr_mode;
 char t_set_l, t_hyst_l, t_set, t_hyst, t_mode;
 unsigned short t_set_h, t_hyst_h;
 char cent, dec, uni;
 char config = 0;
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/mcp8901_lib.c"
#line 9 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/mcp8901_lib.c"
 const char addr = 0b10010000;

 char temp_msb, temp_lsb;
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
#line 80 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
 sbit scl at LATA4_bit;
 sbit sda at LATA5_bit;
 sbit SCL_Direction at TRISA4_bit;
 sbit sdi_Direction at TRISA5_bit;

 sbit sdi at RA5_bit;






 void I2C_Init() {
 scl_Direction = 0;
 sdi_Direction = 0;
 }

 void I2C_Delay() {
 unsigned short i;
 for (i=0; i<=  20 ; i++) {
 Delay_us(1);
 }
 }

 void sclHi() {
 scl = 1;
 I2C_Delay();
 }

void sdaHi() {
 sda = 1;
 I2C_Delay();
}

void sclLo() {
 scl = 0;
 I2C_Delay();
}

void sdaLo() {
 sda = 0;
 I2C_Delay();
}

 void start() {
 sdaHi();
 sclHi();
 I2C_Delay();
 sdaLo();
 I2C_Delay();
 sclLo();
 I2C_Delay();
 }

 void stop() {
 sdaLo();
 I2C_Delay();
 sclHi();
 I2C_Delay();
 sdaHi();
 I2C_Delay();
 }

 void clockPulse() {

 sclHi();
 I2C_Delay();
 sclLo();
 }

 void writeByte(char data_byte) {
 char i;
 for (i = 0; i < 8; i++) {
 if (data_byte.B7)sdaHi();
 else sdaLo();
 data_byte <<=1;
 clockPulse();
 }
 }

 unsigned short readBit() {
 unsigned short out_bit;
 sdi_Direction = 1;
 sclHi();
 out_bit = sdi;
 sclLo();
 sdi_Direction = 0;
 return out_bit;
 }

 unsigned short readByte() {
 unsigned short out_byte = 0, i;

 sdaHi();

 for (i = 0; i < 8; i++) {
 out_byte <<=1;
 out_byte.B0 = readBit();
 }

 return out_byte;
 }
#line 186 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
 unsigned short readAck() {
 sdaHi();
 return readBit() == 0 ? 0 : 1;
 }
#line 194 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
 unsigned short readNack() {
 sdaHi();
 return readBit() == 1 ? 0 : 1;
 }


 void Write_Ack() {
 sdaLo();
 sclHi();
 I2C_Delay();
 sclLo();
 }


 void Write_Nack() {
 sdaHi();
 sclHi();
 I2C_Delay();
 sclLo();
 }
#line 217 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
 unsigned short doStartWriteAckStop(char data_byte) {
 start();
 writeByte(data_byte);

 if (readAck()) {
 return 1;
 }
 stop();
 return 0;
 }
#line 231 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/i2c_soft_j.c"
 unsigned short doStartWriteAckStop_Sring(char data_bytes[], char data_length) {
 unsigned short i;
 start();
 for (i = 0; i < data_length; i++) {
 writeByte(data_bytes[i]);
 if (readAck()) {
 return 1;
 }
 }
 stop();
 return 0;
 }
#line 15 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/mcp8901_lib.c"
 extern void Delay_msec(unsigned int count_delay);




 char dec_to_bcd (char value) {
 char buf;

 buf = value / 10;
 value -= buf * 10;
 buf <<= 4;
 return buf + value;
 }



 char bcd_to_dec (char value) {
 char buf;

 buf = value >> 4;
 buf *= 10;
 buf += value & 0x0F;
 return buf;
 }




 void Init_MCP8901(char config) {
 char buf;

 start();
 writeByte(addr);
 readAck();
 writeByte(0x01);
 readAck();
 writeByte(config);
 readAck();
 stop();
 Delay_msec(10);
 }



 void MCP8901_Write(char addr_reg, char dath, char datl) {
 char buf;

 start();
 writeByte(addr);
 readAck();
 writeByte(addr_reg);
 readAck();
 writeByte(dath);
 readAck();
 writeByte(datl);
 readAck();
 stop();
 }



 void MCP8901_Read(char addr_reg) {

 start();
 writeByte(addr);
 data1 = readAck()+0x30;
 writeByte(addr_reg);
 data2 = readAck()+0x30;
 start();
 writeByte(addr+1);
 data3 = readAck()+0x30;
 temp_msb = readByte();
 Write_Ack();
 temp_lsb = readByte();
 Write_Nack();
 stop();
 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/init_pic16f182x.c"
#line 10 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/init_pic16f182x.c"
 void Init_PIC () {


 ANSELA = 0b00000000;
 ANSELB = 0b00000000;
 ANSELC = 0b00000000;
 ADCON0 = 0b00001000;
 ADCON1 = 0b10100011;

 FVRCON = 0b00000001;




 C1ON_bit = 0;
 C2ON_bit = 0;

 MDCON = 0b00000000;


 OSCCON = 0b11110000;

 OPTION_REG = 0b00000111;
 TMR0 = 0;
 INTCON.TMR0IF = 0;







 INTCON &= 0b00111111;


 CCP1CON = 0b00000000;
 CCP2CON = 0b00000000;







 PORTA = 0;
 PORTB = 0;
 PORTC = 0;
 TRISA = 0b11000110;
 TRISB = 0b00000000;
 TRISC = 0b01001001;
 WPUA = 0b00110100;
 WPUB = 0b11110000;
 WPUC = 0b01111001;
 OPTION_REG.B7 =0;

 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/nokia3310_lib_v2.c"
#line 17 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/nokia3310_lib_v2.c"
 char cen_fm, dec_fm, uni_fm, decimi_fm, centesimi_fm;
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/oscillo_nokia_10x48.h"






unsigned char const mode_0[26] = {
 0, 255, 68, 68, 68, 68, 68, 68, 68,
 68, 68, 124, 64, 64, 64, 64, 64, 64, 64, 64, 64,
 64, 64, 64, 64, 0
};






unsigned char const mode_1[26] = {
 0, 255, 64, 64, 64, 64, 64, 64, 64,
 64, 64, 124, 68, 68, 68, 68, 68, 68, 68, 68, 68,
 68, 68, 68, 68, 0
};







unsigned char const Oscillo_Nokia_10x48 [] = {
0x09,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x00,
0x21,0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x00,
0x84,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x42,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,
0x88,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x00
} ;






unsigned char const mikro_bmp[504] = {
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 7, 71, 99, 99, 99,
 99, 99, 99, 99, 103, 7, 143, 255, 255, 63, 63, 31,
 15, 15, 7, 7, 7, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 7, 7, 7, 15, 15, 31, 31, 63, 255, 255,
255, 255, 255, 255, 255, 0, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 14, 12, 12, 28, 60,
 60, 60, 60, 60, 252, 254, 255, 3, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 248, 254, 254, 254, 252,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
 15, 255, 255, 255, 255, 0, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 34, 102, 6, 6, 30,
 14, 6, 6, 34, 255, 255, 255, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 3,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 255, 255, 0, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 196, 254, 222, 198, 198,
198, 198, 198, 198, 255, 255, 255, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 254, 255, 255, 255, 255,
255, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
 7, 255, 255, 255, 255, 0, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 16, 24, 24, 24, 24,
 24, 24, 24, 24, 27, 63, 255, 224, 128, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 15, 63, 127, 63, 63,
 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128,
240, 255, 255, 255, 255, 0, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 255, 255, 0, 255, 255, 255, 224, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 231, 238, 252, 248,
248, 240, 240, 224, 224, 224, 224, 224, 224, 224, 224, 224,
224, 224, 224, 224, 224, 240, 240, 248, 252, 254, 255, 255,
255, 255, 255, 255, 127, 128, 255, 255, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};





unsigned char const JUMBO70x40_bmp[504] = {
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 128, 254, 255, 255, 31, 0, 224, 255,
255, 255, 15, 0, 0, 192, 254, 255, 255, 31, 0, 128,
254, 255, 255, 255, 255, 255, 240, 248, 254, 255, 255, 255,
255, 63, 0, 128, 254, 255, 255, 127, 99, 99, 247, 255,
255, 190, 0, 0, 248, 252, 254, 127, 15, 7, 3, 7,
207, 255, 254, 252, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 4, 24, 24, 28, 31, 31, 15, 3, 0, 0, 15, 31,
 31, 29, 28, 28, 28, 31, 31, 15, 3, 0, 16, 31,
 31, 31, 7, 15, 31, 31, 31, 7, 17, 31, 31, 31,
 7, 0, 16, 31, 31, 31, 31, 24, 24, 28, 28, 31,
 31, 15, 0, 0, 7, 15, 31, 30, 28, 24, 28, 30,
 31, 15, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 128, 192, 224, 160, 224, 192, 0, 128, 248, 120,
 0, 128, 192, 224, 160, 224, 192, 0, 32, 224, 240, 48,
 32, 32, 224, 240, 48, 32, 128, 224, 96, 32, 32, 192,
224, 32, 224, 224, 0, 0, 128, 224, 96, 32, 224, 192,
 0, 128, 232, 104, 0, 128, 192, 96, 32, 96, 64, 0,
 0, 160, 160, 160, 224, 192, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 3, 7, 4, 4, 6, 2, 0, 7, 7, 0,
 0, 3, 7, 4, 4, 6, 2, 0, 7, 7, 4, 4,
 0, 7, 7, 4, 4, 0, 7, 7, 0, 0, 0, 7,
 7, 4, 7, 3, 0, 0, 7, 7, 0, 7, 7, 0,
 0, 7, 7, 0, 0, 3, 7, 4, 4, 6, 2, 0,
 7, 7, 4, 7, 7, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};





unsigned char const che_guevara_84x48_bmp[504] = {
 0, 128, 128, 192, 193, 225, 225, 225, 129, 129, 129, 252,
252, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 127, 127, 127, 127, 127,
127, 127, 127, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
254, 252, 252, 252, 248, 240, 224, 128, 0, 0, 0, 0,
 0, 231, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 127, 15, 47, 127, 255, 251, 251, 251,
243, 131, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 31, 255, 255, 255, 255, 255, 255, 255, 8,
 0, 0, 0, 3, 3, 7, 63, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 248, 192, 0,
248, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
223, 0, 0, 0, 0, 248, 254, 254, 248, 15, 255, 255,
255, 131, 208, 252, 188, 128, 255, 254, 255, 158, 0, 0,
 0, 128, 192, 192, 132, 191, 191, 191, 191, 159, 15, 0,
 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 254, 248, 248, 254, 255, 255, 255, 255, 255, 255, 255,
255, 255, 127, 31, 15, 63, 63, 63, 31, 15, 30, 4,
 7, 15, 31, 223, 255, 255, 255, 255, 255, 255, 255, 0,
 0, 0, 0, 0, 0, 192, 252, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 3, 0,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 254, 248, 248, 240, 224, 224,
192, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
192, 224, 224, 248, 254, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 15, 3, 1, 0, 0, 0,
 15, 223, 223, 143, 239, 127, 127, 127, 31, 31, 31, 15,
 15, 15, 15, 31, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 127, 31, 15, 7, 0, 0, 0, 0, 0, 0, 0
};






unsigned char const resistenza[84] = {
0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 24,
 24, 12, 6, 3, 6, 12, 24, 48, 96, 192, 96, 48,
 24, 12, 6, 3, 6, 12, 24, 48, 96, 192, 96, 48,
 24, 12, 6, 3, 6, 12, 24, 48, 96, 192, 96, 48,
 24, 12, 6, 3, 6, 12, 24, 48, 96, 192, 96, 48,
 24, 12, 6, 3, 6, 12, 24, 24, 255, 255, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/font_nokia.c"
#line 11 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/font_nokia.c"
const char table[490] = {
 0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x5f,0x00,0x00,
 0x00,0x07,0x00,0x07,0x00,
 0x14,0x7f,0x14,0x7f,0x14,
 0x24,0x2a,0x7f,0x2a,0x12,
 0x23,0x13,0x08,0x64,0x62,
 0x60,0x60,0x7F,0x03,0x03,
 0x03,0x03,0x00,0x00,0x00,
 0x00,0x1c,0x22,0x41,0x00,
 0x00,0x41,0x22,0x1c,0x00,
 0x14,0x08,0x3e,0x08,0x14,
 0x08,0x08,0x3e,0x08,0x08,
 0x00,0x50,0x30,0x00,0x00,
 0x08,0x08,0x08,0x08,0x08,
 0x00,0x60,0x60,0x00,0x00,
 0x20,0x10,0x08,0x04,0x02,
 0x3e,0x51,0x49,0x45,0x3e,
 0x00,0x42,0x7f,0x40,0x00,
 0x42,0x61,0x51,0x49,0x46,
 0x21,0x41,0x45,0x4b,0x31,
 0x18,0x14,0x12,0x7f,0x10,
 0x27,0x45,0x45,0x45,0x39,
 0x3c,0x4a,0x49,0x49,0x30,
 0x01,0x71,0x09,0x05,0x03,
 0x36,0x49,0x49,0x49,0x36,
 0x06,0x49,0x49,0x29,0x1e,
 0x00,0x36,0x36,0x00,0x00,
 0x00,0x56,0x36,0x00,0x00,
 0x08,0x14,0x22,0x41,0x00,
 0x14,0x14,0x14,0x14,0x14,
 0x00,0x41,0x22,0x14,0x08,
 0x02,0x01,0x51,0x09,0x06,
 0x32,0x49,0x79,0x41,0x3e,
 0x7e,0x11,0x11,0x11,0x7e,
 0x7f,0x49,0x49,0x49,0x36,
 0x3e,0x41,0x41,0x41,0x22,
 0x7f,0x41,0x41,0x22,0x1c,
 0x7f,0x49,0x49,0x49,0x41,
 0x7f,0x09,0x09,0x09,0x01,
 0x3e,0x41,0x49,0x49,0x7a,
 0x7f,0x08,0x08,0x08,0x7f,
 0x00,0x41,0x7f,0x41,0x00,
 0x20,0x40,0x41,0x3f,0x01,
 0x7f,0x08,0x14,0x22,0x41,
 0x7f,0x40,0x40,0x40,0x40,
 0x7f,0x02,0x0c,0x02,0x7f,
 0x7f,0x04,0x08,0x10,0x7f,
 0x3e,0x41,0x41,0x41,0x3e,
 0x7f,0x09,0x09,0x09,0x06,
 0x3e,0x41,0x51,0x21,0x5e,
 0x7f,0x09,0x19,0x29,0x46,
 0x46,0x49,0x49,0x49,0x31,
 0x01,0x01,0x7f,0x01,0x01,
 0x3f,0x40,0x40,0x40,0x3f,
 0x1f,0x20,0x40,0x20,0x1f,
 0x3f,0x40,0x38,0x40,0x3f,
 0x63,0x14,0x08,0x14,0x63,
 0x07,0x08,0x70,0x08,0x07,
 0x61,0x51,0x49,0x45,0x43,
 0x00,0x7f,0x41,0x41,0x00,
 0x02,0x04,0x08,0x10,0x20,
 0x00,0x41,0x41,0x7f,0x00,
 0x04,0x02,0x01,0x02,0x04,
 0x40,0x40,0x40,0x40,0x40,
 0x00,0x01,0x02,0x04,0x00,
 0x20,0x54,0x54,0x54,0x78,
 0x7f,0x48,0x44,0x44,0x38,
 0x38,0x44,0x44,0x44,0x20,
 0x38,0x44,0x44,0x48,0x7f,
 0x38,0x54,0x54,0x54,0x18,
 0x08,0x7e,0x09,0x01,0x02,
 0x0c,0x52,0x52,0x52,0x3e,
 0x7f,0x08,0x04,0x04,0x78,
 0x00,0x44,0x7d,0x40,0x00,
 0x20,0x40,0x44,0x3d,0x00,
 0x7f,0x10,0x28,0x44,0x00,
 0x00,0x41,0x7f,0x40,0x00,
 0x7c,0x04,0x18,0x04,0x78,
 0x7c,0x08,0x04,0x04,0x78,
 0x38,0x44,0x44,0x44,0x38,
 0x7c,0x14,0x14,0x14,0x08,
 0x08,0x14,0x14,0x18,0x7c,
 0x7c,0x08,0x04,0x04,0x08,
 0x48,0x54,0x54,0x54,0x20,
 0x04,0x3f,0x44,0x40,0x20,
 0x3c,0x40,0x40,0x20,0x7c,
 0x1c,0x20,0x40,0x20,0x1c,
 0x3c,0x40,0x30,0x40,0x3c,
 0x44,0x28,0x10,0x28,0x44,
 0x0c,0x50,0x50,0x50,0x3c,
 0x44,0x64,0x54,0x4c,0x44,
 0x00,0x08,0x36,0x41,0x00,
 0x00,0x00,0x7f,0x00,0x00,
 0x00,0x41,0x36,0x08,0x00,
 0x0D,0x30,0x6D,0x30,0x0D,
 0x18,0x3C,0x7E,0x18,0x18,
 0xfc,0x20,0x40,0x40,0x7c,
 0x00,0x02,0x05,0x02,0x00
 } ;




const char Font16x10[] = {
 0xF8,0xFE,0x07,0x03,0x03,0x03,0x03,0x07,0xFE,0xF8,
 0x1F,0x7F,0xE0,0xC0,0xC0,0xC0,0xC0,0xE0,0x7F,0x1F,
 0x00,0x18,0x1C,0x0E,0xFF,0xFF,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0xC0,0xFF,0xFF,0xC0,0x00,0x00,0x00,
 0x08,0x0E,0x06,0x03,0x03,0x03,0x83,0xC6,0xFE,0x78,
 0xE0,0xF0,0xF8,0xDC,0xCE,0xC7,0xC3,0xC1,0xC0,0xC0,
 0x03,0x83,0x83,0x83,0x83,0x83,0x83,0xC7,0x7E,0x3C,
 0xC0,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xE3,0x7E,0x3C,
 0x00,0x80,0xC0,0xE0,0x70,0x38,0x1C,0x0E,0x07,0x03,
 0x3F,0x3F,0x31,0x30,0x30,0x30,0x30,0x30,0xFC,0xFC,
 0xFF,0xFF,0xC3,0xC3,0xC3,0xC3,0xC3,0xC3,0x83,0x03,
 0x20,0x60,0xE0,0xC0,0xC0,0xC0,0xC0,0xE1,0x7F,0x3F,
 0xFC,0xFE,0x87,0x83,0x83,0x83,0x83,0x83,0x06,0x04,
 0x3F,0x7F,0xE1,0xC1,0xC1,0xC1,0xC1,0xE3,0x7F,0x3E,
 0x03,0x03,0x03,0x03,0x03,0x03,0x83,0xC3,0xFF,0x7F,
 0x00,0x00,0x00,0x00,0xFE,0xFF,0x03,0x01,0x00,0x00,
 0x3C,0x7E,0xC7,0x83,0x83,0x83,0x83,0xC7,0x7E,0x3C,
 0x3C,0x7E,0xE3,0xC1,0xC1,0xC1,0xC1,0xE3,0x7E,0x3C,
 0x7C,0xFE,0xC7,0x83,0x83,0x83,0x83,0x87,0xFE,0xFC,
 0x20,0x60,0xE1,0xC1,0xC1,0xC1,0xC1,0xE1,0x7F,0x3F,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

 0x00,0x98,0x78,0x38,0x00,0x00,0x00,0x00,0x00,0x00,

 0x00,0x18,0x38,0x18,0x00,0x00,0x00,0x00,0x00,0x00,

 0x00,0x1C,0x36,0x36,0x1C,0x00,0x00,0x00,0x00,0x00,

 };








 unsigned char const volume_str[19] = {
 128, 128, 192, 192, 224, 224, 240, 240, 248, 248, 252, 252, 254, 254, 255, 255
 };
#line 23 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/nokia3310_lib_v2.c"
void Dec_BCD_Short (unsigned short, unsigned short, unsigned short, unsigned short);
void Decimale_BCD (unsigned int, unsigned short, unsigned short, unsigned short);
void Delay_2us ();
void Delay_msec (unsigned int);
void initlcd(void);
void writecom(char);
void writedata(char);
void clockdata(char);
void clearram(void);
void cursorxy(char,char);
void nokia_erase_y(char);
void nokia_erase_x(char);
void nokia_plot(char,char);
void nokia_write_data_inv(char);
void putchar(char,char);
void putstr(const char *);
void inicpu();
void Write_Bitmap();
void Draw_line_vert_KS0713(unsigned char, unsigned char, unsigned char, char);

 unsigned char const Byte_LOW [8] ={0b11111111,0b11111110,0b11111100,0b11111000,
 0b11110000,0b11100000,0b11000000,0b10000000};
 unsigned char const Byte_HIGH [8] ={0b00000001,0b00000011,0b00000111,0b00001111,
 0b00011111,0b00111111,0b01111111,0b11111111};




 void Delay_2us () {
 asm nop
 }

void initlcd(void)
{
  LATC.F7  = 1;
 Delay_msec(2);
  LATB.F7  = 0;
 Delay_msec(2);
  LATC.F7  = 0;
 Delay_msec(100);
 Delay_msec(2);
  LATC.F7  = 1;
 Delay_msec(2);

 writecom(0x21);
 writecom(0xC2);
 writecom(0x13);
 writecom(0x20);
 writecom(0x09);
 delay_ms(100);

 writecom(0x08);
 delay_msec(100);
 writecom(0x0C);

 delay_msec(100);
 cursorxy(0,0);
 clearram();
}

void writecom(char command_in)
{
  LATB.F6  = 0;
 Delay_2us();
  LATB.F7  = 0;
 Delay_2us();
 clockdata(command_in);
  LATB.F7  = 1;
 Delay_2us();
}

void writedata(char data_in)
{
  LATB.F6  = 1;
 Delay_2us();
  LATB.F7  = 0;
 Delay_2us();
 clockdata(data_in);
  LATB.F7  = 1;
 Delay_2us();
}

 void clockdata(char bits_in){
 int bitcnt;
 for (bitcnt=8; bitcnt>0; bitcnt--){
  LATB.F4  = 0;
 Delay_2us();

 if ((bits_in&0x80)==0x80)
 {
  LATB.F5 =1;
 Delay_2us();
 }
 else
 {
  LATB.F5 =0;
 Delay_2us();
 }
  LATB.F4  = 1;
 Delay_2us();


 bits_in=bits_in<<1;


 }
}

void clearram(void)
{
 int ddram;
 cursorxy(0,0);

 for (ddram=504;ddram>0;ddram--) writedata(0x00);
}

void cursorxy(char x, char y)
{
 writecom(0x40|(y&0x07));
 writecom(0x80|(x&0x7f));
}

void Set_Colonna_x(char x)
{
 writecom(0x80|(x&0x7f));
}

void Set_Page_y(char y)
{
 writecom(0x40|(y&0x07));
}

 void nokia_erase_y(char ynokia) {
 char row;

 for(row=0;row<79;row++) {
 cursorxy(row,ynokia);
 putchar(' ', 0);
 }
 }

 void nokia_erase_x(char xnokia) {
 char column;

 for (column=0;column!=6;column++){
 cursorxy(xnokia,column);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 }
 }


 void nokia_colonna_Bitmap(char colonna) {
 unsigned char page_y, temp;

 temp = colonna;
 while (temp >= 10) {
 temp -= 10;
 }
 for (page_y=0; page_y<=5; page_y++){
 cursorxy(colonna, page_y);

 }
 }

void Draw_line_oriz_3310(unsigned short X1, unsigned short X2, unsigned short posizione) {



}





void Write_Font_16x10(unsigned short Carattere, unsigned short page, unsigned short colonna) {
 unsigned short temp_count, indice_carattere, indice = 0;

 indice_carattere = 10;
 indice_carattere *= (Carattere * 2);
 temp_count = 0;
 if (Carattere == 11) { indice_carattere = 220; Page ++; }

 _loop:

 temp_count = 0;

 Set_Page_y(page);
 Set_Colonna_x(colonna) ;

 while (temp_count <= 9) {
 writedata(Font16x10 [indice_carattere]);
 indice ++;
 indice_carattere ++;
 temp_count ++;
 }
 writedata(0);

 if (indice_carattere >= 222) { return; }
 if (indice <= 12) {
 Page ++;
 goto _loop;
 }
}



 void Frequenza_16x10(char page, char colonna) {
 short i;

 if (cen_fm == 1) {
 Write_Font_16x10(cen_fm, page, colonna);
 }
 else Write_Font_16x10(10, page, colonna);
 Write_Font_16x10(dec_fm, page, colonna + 12);
 Write_Font_16x10(uni_fm, page, colonna + 24);
 Write_Font_16x10(11, page, colonna + 36);
 Write_Font_16x10(decimi_fm, page, colonna + 44);
 Write_Font_16x10(centesimi_fm, page, colonna + 56);

 }




 void putchar(char character, char doppio){
 int tablept;
 char count, char_column;

 if ((character<0x20)||(character>0x80)) return;
 tablept = (character - 0x20) * 5;

 for (count=5;count>0;count--) {
 if (doppio.F7) char_column = ~table[tablept];
 else char_column = table[tablept];

 writedata(char_column);
 if (doppio.F0) writedata(char_column);
 tablept++;
 }
 if (doppio.F7) writedata(0xFF);
 else writedata(0x00);


 }










void Write_Double_String(char string[], unsigned char Page, unsigned char colonna, char pos_virgola) {
 unsigned short i = 0, ii, temp_count, _data;
 char temp2;
 unsigned int temp;

 cursorxy(colonna, (Page & 0x0F));

 temp_count = 0;

 for (ii=0; ii<2; ii++) {

 while (string [i] != 0) {
 temp = string [i];
 if (temp == 176) temp = 0x81;
 temp -= 0x20;
 temp *= 5;

 while (temp_count <= 4) {
 if (Page.F7) _data = ~table[temp];
 else _data = table[temp];

 if (ii ==0) {
 temp2 =0x00;
 if (_data.B0) {
 temp2.B1 = 1;
 temp2.B2 = 1;
 }
 if (_data.B1) {
 temp2.B3 = 1;
 temp2.B4 = 1;
 }
 if (_data.B2) {
 temp2.B5 = 1;
 temp2.B6 = 1;
 }
 if(_data.B3) temp2.B7 = 1;

 }
 else {
 temp2 =0x00;
 if(_data.B3) temp2.B0 = 1;
 if (_data.B4) {
 temp2.B1 = 1;
 temp2.B2 = 1;
 }
 if (_data.B5) {
 temp2.B3 = 1;
 temp2.B4 = 1;
 }
 if (_data.B6) {
 temp2.B5 = 1;
 temp2.B6 = 1;
 }

 }

 writedata(temp2);
 writedata(temp2);
 temp_count ++;
 temp ++;
 }

 if (Page.F7) {
 writedata(0xFF);
 writedata(0xFF);
 }
 else {
 writedata(0x00);
 writedata(0x00);
 }
 i ++;
 temp_count = 0;
 if (i == pos_virgola && ii == 0) {
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 writedata(0x00);
 }
 else if (i == pos_virgola && ii == 1){
 writedata(0x98);
 writedata(0x78);
 writedata(0x38);
 writedata(0x00);
 writedata(0x00);
 }
 }


 cursorxy(colonna, (Page & 0x0F)+1);
 i = 0;
 }


 }

void putstr(const char *s)
{
 while(*s) {putchar(*s++, 0);}

}







void Write_String(char string[], unsigned char Page, unsigned char colonna) {
 unsigned short i = 0, temp_count, _Data;
 int temp;

 cursorxy(colonna, (Page & 0x0F));

 temp_count = 0;


 while (string [i] != 0) {
 temp = string [i];
 temp -= 0x20;
 temp *= 5;

 while (temp_count <= 4) {
 if (Page.F7) _Data = ~table[temp];
 else _Data = table[temp];
 writedata(_Data);
 if (page.B6) writedata(_Data);
 temp_count ++;
 temp ++;
 }

 if (Page.F7) writedata(0xFF);
 else writedata(0x00);
 i ++;
 temp_count = 0;
 }
 }




 void Write_Bitmap(char bmp) {

 unsigned int bitmap_byte=0;
 unsigned int max_bitmap_byte = 503;
 if (bmp == 4) max_bitmap_byte = 83;


 cursorxy(0, 0);

  LATB.F6  = 1;
 Delay_2us();
  LATB.F7  = 0;
 Delay_2us();
 do {




 if (bmp == 4) clockdata (resistenza [bitmap_byte]);

 } while (++bitmap_byte <= max_bitmap_byte);
  LATB.F7  = 1;
 }










 void Write_Bitmap_page(char *bmp, char page, char col, char length) {
 char buf = 0, buf1;

 buf1 = page & 0x0F;
 cursorxy(col, buf1);

 while (buf <= length){
 buf1 = bmp[buf];
 if (page.B7) buf1 = ~bmp[buf];
 else buf1 = bmp[buf];
 writedata(buf1);
 buf ++;
 }
 }








 void Draw_line_vert_3310(unsigned char Y1, unsigned char Y2, unsigned char colonna, char colore) {
 unsigned char temp_1, temp_2, temp_count, page_1, page_2, _data;

 if (colonna >=84) colonna = 83;
 if (Y1 >= 48) Y1 = 48;
 if (Y2 >= 48) Y2 = 48;

 if (Y1 > Y2) {temp_1 = Y2 ; Y2 = Y1; Y1 = temp_1;}
 page_1 = Y1 >> 3;
 temp_1 = page_1;
 page_2 = Y2 >> 3;
 temp_2 = page_2;
 Y1 &= 0x07;
 Y2 &= 0x07;

 if (page_1 == page_2) {
 cursorxy(colonna, page_1);
 if (colore) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2]);
 else writedata (0x00);
 return;
 }

 page_1 += 1;
 if (colore) _data = 0xFF ;
 else _data = 0x00 ;
 while (page_1 < page_2) {
 cursorxy(colonna, page_1);
 writedata (_data);
 page_1 ++;
 }

 cursorxy(colonna, temp_1);
 if (colore) writedata (Byte_LOW [Y1]);
 else writedata (0x00);

 cursorxy(colonna, temp_2);
 if (colore) writedata (Byte_HIGH [Y2]);

 else writedata (0x00);
}










void Dec_BCD_Short (unsigned short Value, unsigned short page, unsigned short colonna, unsigned short width) {
 unsigned short buffer;
 unsigned short interi, decimi, centesimi;

 if (page >= 6) return;
 cursorxy(colonna, page);


 interi = Value / 100 ;
 buffer = Value - (interi * 100) ;
 decimi = buffer / 10;
 centesimi = buffer - (decimi * 10) ;



 if (interi != 0) putchar(interi+48, width);

 if (interi == 0 && decimi == 0 && width.F1 == 0) putchar(32, width);
 else putchar(decimi+48, width);
 putchar(centesimi+48, width);
 }

void Decimale_BCD (unsigned int Value, unsigned short page, unsigned short colonna, unsigned short Width) {
 unsigned int buffer;
 unsigned short interi, decimi, centesimi, millesimi;
 if (Value >= 9999) Value = 9999;
 cursorxy(colonna, page);

 interi = Value / 1000 ;
 buffer = Value - (interi * 1000) ;
 decimi = buffer / 100;
 buffer = buffer - (decimi * 100) ;
 centesimi = buffer / 10;
 millesimi = buffer - (centesimi * 10) ;

 if (page >= 5) return;
 if (Width.F6) { goto Decimale_BCD_loop; }
 else {
 if (interi == 0 && Width.F5 == 1) putchar(32, 0);
 else putchar(interi+48, 0);
 colonna += 6;
 if (Width.F5 == 0) {
 putchar(',', 0);
 colonna += 3;
 }
 }

 Decimale_BCD_loop:
 putchar(decimi+48, 0);
 colonna += 6;
 putchar(centesimi+48, 0);
 colonna += 6;
 if (Width.F6) {
 putchar(',', 0);
 colonna += 3;
 putchar(millesimi+48, 0);
 }
 else putchar(millesimi+48, 0);
#line 601 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/nokia3310_lib_v2.c"
 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/pulsanti.c"
#line 26 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/mcp9801_temperatura/mcp8901 sonda temp/pulsanti.c"
 sbit up at RC3_bit;
 sbit dw at RC6_bit;
 sbit set at RC0_bit;
 extern void dec_to_str (char value, char zero);

 const char delay_pul = 50;
 const char delay_pul_set = 50;

 char cnt_pul;
 char cnt_repeat = 0, cnt_n_repeat;
 char state_pul;

 typedef struct {
 unsigned pul : 1;
 unsigned up_dw : 1;
 unsigned r_1000 : 1;
 unsigned r_10000 : 1;
 unsigned led : 1;

 } Flagsp;
 Flagsp flag_;

 void Wait();
 void Delay_Repeat();







 void Puls(){

 state_pul = 0;
 if (up==0 && flag_.pul==0) {
 cnt_pul = (delay_pul - cnt_repeat);
 flag_.pul = 1;
 state_pul = 1;
 flag_.up_dw = 1;

 }
 if (dw==0 && flag_.pul==0) {
 cnt_pul = (delay_pul - cnt_repeat);
 flag_.pul = 1;
 state_pul = 2;
 flag_.up_dw = 1;

 }
 if (set==0 && flag_.pul==0) {
 cnt_pul = delay_pul_set;
 flag_.pul = 1;
 state_pul = 3;
 flag_.up_dw = 0;

 }
 if (flag_.up_dw == 1) Delay_Repeat();
 else Wait();
 if (up && dw && set) Wait();

 }




 void Wait(){

 if (up && dw && set) {
 cnt_pul --;
 if (cnt_pul ==0) flag_.pul = 0;
 cnt_repeat = 0;
 }
 else cnt_pul = delay_pul_set;
 flag_.up_dw = 0;
 }




 void Delay_Repeat(){

 cnt_pul --;
 if (cnt_pul >= 250) {
 flag_.pul = 0;
 cnt_repeat ++;
 if (cnt_repeat >= 45) cnt_repeat = 45;

 }
 }
#line 177 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/MCP9801_Temperatura/MCP8901 Sonda Temp/MCP8901_Sonda_Temp.c"
 void Delay_msec (unsigned int count_delay) {
 for (count_delay; count_delay > 0; count_delay --) {
 Delay_ms (1) ;
 asm { clrwdt }
 }
 }



 char Calc_Decimale () {
 unsigned int buf;

 buf = 625 * (temp_lsb >> 4);
 return buf / 1000;
 }



 void dec_to_str (char value, char zero) {
 char cnt = 0;

 if (value >= 0x80) {
 txt[0] = '-';
 value -= 0x80;
 }
 else {
 txt[0] = (value / 100);
 value = value - (txt[0]*100);
 txt[0] += 0x30;
 }
 txt[1] = value / 10;
 txt[2] = (value - (txt[1] * 10)) + 0x30 ;
 txt[3]=0;
 if (txt[0] == 0x30 && zero == 0) txt[0] = ' ';

 if (txt[1] == 0 && txt[0] == ' ' && zero == 0) txt[1] = ' ';
 else txt[1] = txt[1] + 0x30;

 }



 void Main_Page_bis () {
 char buf;

 Write_String(txt_set, 4, 0);
 dec_to_str (t_set, 0);
 Write_String(txt, 4 + contr_set, 27);
 putchar(',', 0x00 + contr_set);

 if (t_set_l >= 0x80) putchar ('5', 0x00 + contr_set);
 else putchar ('0', 0x00 + contr_set);

 Write_String(txt_hyst, 5, 0);
 dec_to_str (t_hyst, 0);
 Write_String(txt, 5 + contr_hyst, 27);
 putchar(',', 0x00 + contr_hyst);

 if (t_hyst_l >= 0x80) putchar ('5', 0x00 + contr_hyst);
 else putchar ('0', 0x00 + contr_hyst);


 if (flag.mode) Write_Bitmap_page(mode_1, 5 + contr_mode, 59, 24);
 else Write_Bitmap_page(mode_0, 5 + contr_mode, 59, 24);

 }



 void Main_Page_Prog () {
 char buf;



 if (t_set_h >= 0x80) {
 t_set = 255 - t_set_h;
 t_set |= 0x80;
 }
 else t_set = t_set_h;

 dec_to_str (t_set, 0);
 Write_String(txt, 4 + contr_set, 27);
 putchar(',', 0x00 + contr_set);

 if (flag.half_set == 0) {
 putchar('0', 0x00 + contr_set);
 }
 else {
 putchar('5', 0x00 + contr_set);
 }


 if (t_hyst_h >= 0x80) {
 t_hyst = 255 - t_hyst_h;
 t_hyst |= 0x80;
 }
 else t_hyst = t_hyst_h;

 dec_to_str (t_hyst, 0);
 Write_String(txt, 5 + contr_hyst, 27);
 putchar(',', 0x00 + contr_hyst);

 if (flag.half_hyst == 0) {
 putchar('0', 0x00 + contr_hyst);
 }
 else {
 putchar('5', 0x00 + contr_hyst);
 }



 if (flag.mode) Write_Bitmap_page(mode_1, 5 + contr_mode, 59, 24);


 else Write_Bitmap_page(mode_0, 5 + contr_mode, 59, 24);

 }






 void Main_Page () {
 char buf;

 dec_to_str (temp_msb, 0);
 Write_Double_String(txt, 2, 0, 0);
 txt[0] = ','; txt[1]= 0 ;
 Write_Double_String(txt, 2, 35, 0);
 buf = Calc_Decimale ();
 txt[0] = buf + 0x30;
 txt[1] = 0;
 Write_Double_String(txt, 2, 45, 0);
 txt[0] = ''; txt[1]= 'C'; txt[2]= 0;
 Write_Double_String(txt, 2, 60, 0);

 if (alert) {
 Write_String(txt_on, 4, 70);
 LED_2 = 1;
 }
 else {
 Write_String(txt_off, 4, 70);
 LED_2 = 0;
 }
 }








 void Program(){
 char cnt = 1;

 MCP8901_Read(2);
 t_hyst_h = temp_msb;
 t_hyst_l = temp_lsb;
 if (t_hyst_h >= 0x80) {
 t_hyst = 255 - t_hyst_h;
 t_hyst += 0x80;
 }
 else t_hyst = t_hyst_h;
 t_hyst_h = t_hyst;
 if (t_hyst_l >= 0x80) flag.half_hyst = 1;
 else flag.half_hyst = 0;
 MCP8901_Read(3);
 t_set_h = temp_msb;
 t_set_l = temp_lsb;
 if (t_set_h >= 0x80) {
 t_set = 255 - t_set_h;
 t_set += 0x80;
 }
 else t_set = t_set_h;
 t_set_h = t_set;
 if (t_set_l >= 0x80) flag.half_set = 1;
 else flag.half_set = 0;

 while (1) {
 Puls();
 if (state_pul == 3) cnt ++;

 switch (cnt) {
 case (1): contr_set = 0x80;
 if (state_pul == 1) {
 flag.half_set ^= 1;
 if (flag.half_set == 0) {
 t_set_l = 0;
 t_set_h ++;
 if (t_set_h == 126) t_set_h = 125;
 }
 else t_set_l = 0x80;
 }

 if (state_pul == 2) {
 flag.half_set ^= 1;
 if (flag.half_set == 1) {
 t_set_l = 0x80;
 t_set_h --;
 }
 else t_set_l = 0x00;

 if (t_set_h == 199) t_set_h = 200;
 }
 break;
 case (2): contr_set = 0;
 contr_hyst = 0x80;
 if (state_pul == 1) {
 flag.half_hyst ^= 1;
 if (flag.half_hyst == 0) {
 t_hyst_l = 0;
 t_hyst_h ++;
 if (t_hyst_h == 126) t_hyst_h = 125;
 }
 else t_hyst_l = 0x80;
 }

 if (state_pul == 2) {
 flag.half_hyst ^= 1;
 if (flag.half_hyst == 1) {
 t_hyst_l = 0x80;
 t_hyst_h --;
 }
 else t_hyst_l = 0x00;

 if (t_hyst_h == 199) t_hyst_h = 200;
 }
 break;
 case (3): contr_hyst = 0;
 contr_mode = 0x80;
 if (state_pul == 1 || state_pul == 2) flag.mode ^= 1;
 break;
 default: contr_mode = 0;
 MCP8901_Write(2, t_hyst, t_hyst_l);
 EEPROM_Write(0x02, t_hyst);
 EEPROM_Write(0x03, t_hyst_l);
 MCP8901_Write(3, t_set, t_set_l);
 EEPROM_Write(0x00, t_set);
 EEPROM_Write(0x01, t_set_l);
 if (flag.mode) config.B2 = 1;
 else config.B2 = 0;
 EEPROM_Write(0x04, config);
 Init_MCP8901 (config |= 0x60);
 Main_Page_Prog();
 return;
 }
 Main_Page_Prog();
 }
 }



 char Test_EEprom(char addr){
 char buf;

 buf = EEPROM_Read(addr);
 if (buf != 0xFF) return buf;
 else return 0x00;

 }



 void interrupt(){

 }



 void main() {
 char ii=0,iii;
 unsigned short cnt_req;

 Init_PIC();
 Delay_msec(100);
 I2C_Init();
 config = Test_EEprom(0x04);
 Init_MCP8901 (config |= 0x60);
 if (config.B4) flag.mode = 1;
 else flag.mode = 0;
 Delay_msec(500);

 initlcd();

  LATC.F2  =1;
 Delay_msec(100);

 Write_String(jumbo, 0, 5);
 contr_hyst =0;
 contr_set = 0;
 contr_mode = 0;



 t_set_h = Test_EEprom(0x00);
 t_set_l = Test_EEprom(0x01);
 MCP8901_Write(3, t_set_h, t_set_l);
 t_hyst_h = Test_EEprom(0x02);
 t_hyst_l = Test_EEprom(0x03);
 MCP8901_Write(2, t_hyst_h, t_hyst_l);

 MCP8901_Read(3);
 t_set_h = temp_msb;
 t_set_l = temp_lsb;
 t_set = t_set_h;
 MCP8901_Read(2);
 t_hyst_h = temp_msb;
 t_hyst_l = temp_lsb;
 t_hyst = t_hyst_h;
 Main_Page_bis ();

 LED_1 = 1;

 while (1) {
 if (INTCON.TMR0IF) {
 cnt_led ++;
 INTCON.TMR0IF = 0;
 cnt_req ++;
 }
 if (cnt_led >= 50) {
 LED_1 ^= 1;
 cnt_led = 0;
 flag.led ^= 1;
 }

 Puls();
 if (state_pul == 3) Program();


 if (cnt_req>=120) {
 MCP8901_Read (0x00);
 Main_Page();
 cnt_req = 0;
 }
 }
 }
