/*

            Libreria nata con il progetto
                    M8716BB1_Real_Time.c


          GESTIONE PULSANTI   - 3 pulsanti per regolare ora e data
                              - possono essere utilizzati solo 2 pulsanti
                              - UP: aumenta valore selezionato
                              - DW: diminuisce valore selezionato
                              - SET: seleziona valore
                              
            BUTTONS MANAGEMENT - 3 buttons to adjust time and date
 - only 2 buttons can be used
 - UP: increases the selected value
 - DW: decreases the selected value
 - SET: select value
          
          MODIFICARE LA FUNZIONE "Puls()" se i pulsanti non devono essere ripetitivi
                                          se tenuti premuti.
          MODIFY THE "Puls ()" FUNCTION if the buttons are not to be repetitive
     if held down.

*/
//
 sbit up at RC3_bit;   //
 sbit dw at RC6_bit;   //
 sbit set at RC0_bit;   //                   
                                                     extern void dec_to_str (char value, char zero);
//
 const char delay_pul = 50;       // Time for delay initial (repaet)
 const char delay_pul_set = 50;
//
 char cnt_pul;
 char cnt_repeat = 0, cnt_n_repeat;
 char state_pul;
//
 typedef struct {
        unsigned pul          : 1;
        unsigned up_dw        : 1;
        unsigned r_1000       : 1;
        unsigned r_10000      : 1;
        unsigned led          : 1;

 } Flagsp;
  Flagsp flag_;
//
   void Wait();
   void Delay_Repeat();
//
// *****************************************************************************
// SET: premuto non ripete (Wait())
// UP, DW: premuto ripete  (Delay_Repeat())
// SET: if held down don't repeat
// UP, DW: if held down repeat
// *****************************************************************************
 void Puls(){
//
      state_pul = 0;                // 0 = no button pressed
        if (up==0 && flag_.pul==0) {                 // repetitive
          cnt_pul = (delay_pul - cnt_repeat);
           flag_.pul = 1;
            state_pul = 1;          // 1 = UP
             flag_.up_dw = 1;
        // ...
        }
         if (dw==0 && flag_.pul==0) {               // repetitive
          cnt_pul = (delay_pul - cnt_repeat);
           flag_.pul = 1;
            state_pul = 2;          // 2 = DW
             flag_.up_dw = 1;
            // ...
         }
          if (set==0 && flag_.pul==0) {            // not repetitive
           cnt_pul = delay_pul_set;
            flag_.pul = 1;
             state_pul = 3;         // 3 = SET
              flag_.up_dw = 0;
            // ...
          }
            if (flag_.up_dw == 1) Delay_Repeat();   // UP, DW
             else Wait();                           // SET
              if (up && dw && set) Wait();
          //  Wait();
 }
// *****************************************************************************
// Attesa fittizia rilascio pulsante
// Wait release button
// *****************************************************************************
 void Wait(){
//
     if (up && dw && set) {
      cnt_pul --;
       if (cnt_pul ==0) flag_.pul = 0;
        cnt_repeat = 0;
     }
       else cnt_pul = delay_pul_set;
        flag_.up_dw = 0;
 }
// *****************************************************************************
// Ritardo ripetizione pulsante
// Delay repeat button
// *****************************************************************************
 void Delay_Repeat(){
//
      cnt_pul --;
       if (cnt_pul >= 250) {
        flag_.pul = 0;
         cnt_repeat ++;
          if (cnt_repeat >= 45) cnt_repeat = 45;

       }
 }
// *****************************************************************************
/*























*/